import {useEffect, useState} from "react";
import {gqlOnePost} from "../shared/services&utilits/gqlRequest";
import ImgBlock from "./ImgBlock";
import AvaLoginBlock from "./AvaLoginBlock";
import styled from "styled-components";
import LikeBlock from "./LikeBlock";
import TimeOfCreation from "./TimeOfCreation";

const Title = styled.p`
`
const Text = styled.p`
`
const ImgWrapper = styled.div`
  width: 100%;
  max-height: 350px;
  display: flex;
  align-items: center;
`
const LikeWrapper = styled.div`
  display: flex;
  justify-content: space-between;
`

function PostFeed({post}) {
    const [postFeedData, setPostFeedData] = useState(null);
    useEffect(() => {
        if (!postFeedData) {
            gqlOnePost(post._id).then(res => res.json())
                .then(data => setPostFeedData(data["data"].PostFindOne))
        }
    }, [])

    function updPostData() {
        gqlOnePost(post._id).then(res => res.json())
            .then(data => setPostFeedData(data["data"].PostFindOne))
    }

    function handler() {
        // console.log(postFeedData.comments)
    }

    // console.log(postFeedData)
    return (<>
            {post && postFeedData && <>
                <AvaLoginBlock name={postFeedData.owner && postFeedData.owner.login || "Anon"} urlAva={postFeedData.owner && postFeedData.owner.avatar || null}/>

                <ImgWrapper>
                    <ImgBlock images={post.images}/>
                </ImgWrapper>
                <LikeWrapper>
                    <LikeBlock likes={postFeedData.likes} postId={postFeedData._id} updatePostData={updPostData}/>
                    <TimeOfCreation createdTime={postFeedData.createdAt}/>
                </LikeWrapper>
                <Title>{postFeedData.title}</Title>
                <Text>{postFeedData.text}</Text>
                <button onClick={handler}>Show all comments
                    ({postFeedData.comments && postFeedData.comments.length || 0})
                </button>
            </>
            }
        </>
    )
};


export default PostFeed;